/**
 * Created by GoLand.
 * Email: xzghua@gmail.com
 * Date: 2019-09-03
 * Time: 17:26
 */
package main

import "fmt"

type ListNode struct {
	Val int
	Next *ListNode
}

func main()  {
	node1 := &ListNode{Val:1}
	node2 := &ListNode{Val:2}
	node3 := &ListNode{Val:3}
	node4 := &ListNode{Val:4}
	node5 := &ListNode{Val:5}
	node6 := &ListNode{Val:6}
	node7 := &ListNode{Val:7}
	node8 := &ListNode{Val:8}
	node9 := &ListNode{Val:9}
	node10 := &ListNode{Val:10}
	node11 := &ListNode{Val:11}
	node12 := &ListNode{Val:12}
	node1.Next = node2
	node2.Next = node3
	node3.Next = node4
	node4.Next = node5
	node5.Next = node6
	node6.Next = node7
	node7.Next = node8
	node8.Next = node9
	node9.Next = node10
	node10.Next = node11
	node11.Next = node12

	res := reverseKGroup(node1,5)
	fmt.Println("格式")
	for res.Next != nil {
		fmt.Println(res.Val)
		res = res.Next
	}
	fmt.Println(res.Val)
}

// 反转一个普通的链表,返回反转后的链表头节点和最后的末尾节点,
func reverse(head *ListNode) (res *ListNode, h *ListNode) {
	if head == nil || head.Next == nil {
		return head,head
	}
	s,h := reverse(head.Next)
	head.Next.Next = head
	head.Next = nil
	return s,head
}

func reverseK(head,ss *ListNode,k int) (res *ListNode) {
	// 定义一个节点=指针移动k个节点的下个节点
	var headN *ListNode
	// 存储一个当前节点,比如 1->2->3 指针已经移动到了3,但是转换的时候 还是得把1传进去
	oldHead := head
	for i:=0;i<k;i++ {
		// 如果正好符合k个,存储下个节点,把当前的指针的next指向nil,防止循环卡死
		if i == k - 1 {
			headN = head.Next
			head.Next = nil
		} else {
			if head != nil && head.Next != nil {// 如果不够k个,且后续还有节点,指针继续往后移动
				head = head.Next
			} else {// 不符合k个且后续没有节点了,直接返回
				return oldHead
			}
		}
	}
	// 递归,ss存储上个 一组数据反转的结果
	ss = reverseK(headN,ss,k)
	// 把小组数据进行反转,并返回反转后 链表的头节点和末尾节点
	s,h := reverse(oldHead)
	if ss == nil { // 如果是递归最里层,把最里层反转的小组的头节点进行赋值
		ss = s
	} else {
		h.Next = ss // 把当前小组的末尾指向上一层反转的头
	}

	return s
}


func reverseKGroup(head *ListNode, k int) *ListNode {
	// 如果 k = 1 ,直接不用反转了
	if k == 1 {
		return head
	}
	return reverseK(head,nil,k)
}


